--- Visor de imagenes para fishell

ID005VI.cfg_.title = getText("titulo",ID005VI)
ID005VI.cfg_.multiLoad = true
ID005VI.cfg_.title_for_accs = getText("titulo",ID005VI)
ID005VI.path = "ms0:/FISHELL/APP/ID005VI"

---------------------------------------------------------------
---------------------------------------------------------------

ID005VI.img_controles = image.load(ID005VI.path.."/src/controles.png")
ID005VI.img_butt_norm = image.load(ID005VI.path.."/src/butt_norm.png")

--[[ FUNCIONES BASICAS ]]--

function ID005VI.init(id,input) --[[ Aqui se coloca lo que se ejecutar al iniciar la aplicacion (incluyendo la carga de recursos) ]]--
if input == nil then 
	id.path = ID005VI.loadBasic()
else
	if files.exists(input) == true then
		id.path = input
	else
		return
	end
end

id.trans_controls = 255
id.visible_controls = true
id.transbtesp = 0
id.cronoModo = 0

id.blitmode = "scale"
ID005VI.loadImage(id)

end

function ID005VI.run(id) --[[ Aqui se coloca el contenido del programa en ejecucion ]]--

if control.press("r") then
	system.printLabel("load","")
	ID005VI.changeNext(id)
	system.closeLabel()
end

if control.press("l") then
	system.printLabel("load","")
	ID005VI.changeLast(id)
	system.closeLabel()
end

if control.press("back") then
	if id.visible_controls == true then
		id.visible_controls = false
		id.transbtesp = 0
	else
		id.visible_controls = true
	end
end

if id.path ~= nil then fishbar.apps[fishbar.apps_focus].titulo = getText("titulo",ID005VI).." - "..files.nopath(id.path) end

if id.image == nil or id.path == nil then 

	id.trans_controls = 0
	id.visible_controls = false
	
	if id.noimagexist == true then
		screen.print(sdk.x + 232,sdk.y + 100,getText("no se encontro imagen",ID005VI),0.55,color.new(0,0,0),0x0,"center",sdk.w - sdk.x)
	end
	
	screen.print(sdk.x + 232,sdk.y + 90,getText("imagen no cargada",ID005VI),0.55,color.new(0,0,0),0x0,"center",sdk.w - sdk.x)
	return
end

image.blit(id.image,id.imagen_x + sdk.x,id.imagen_y + sdk.y)
 
if puntero.isOver(sdk.x,sdk.y,sdk.w,sdk.h) then
	puntero.overOn("popup")
	if control.press("menu") then
		ID005VI.makePopup(id,id.path)
	end
end

if id.visible_controls == true then
	id.trans_controls = id.trans_controls + 7
else
	id.trans_controls = id.trans_controls - 7
end

if id.trans_controls < 0 then id.trans_controls = 0 end
if id.trans_controls > 255 then id.trans_controls = 255 end

ID005VI.drawControls(id)

end

function ID005VI.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--
	id.image = nil
	id.tmp = nil
end

function ID005VI.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

function ID005VI.drawControls(id)
if id.visible_controls == false and id.trans_controls <= 0 then return end

local crlx = sdk.x + 2

ID005VI.img_controles:blend(crlx,sdk.y + 2,id.trans_controls)

if id.visible_controls == false then return end


if puntero.isOver(crlx + 2,sdk.y + 4,27,23) then --- Pantalla completa
	puntero.overOn("link")
	ID005VI.img_butt_norm:blend(crlx + 2,sdk.y + 4,id.trans_controls)
end

if puntero.isOver(crlx + 2,sdk.y + 29,27,23) then --- modo de pintado
	puntero.overOn("link")
	ID005VI.img_butt_norm:blend(crlx + 2,sdk.y + 29,id.trans_controls)
	if control.press("select") then
		if (id.imagen_w * id.imagen_h) > (512 * 512) then
			system.mensaje(getText("advertencia"),"",getText("no se puede cambiar modo",ID005VI))
			return
		end
		ID005VI.changemode(id)
	end
end

if puntero.isOver(crlx + 2,sdk.y + 54,27,23) then --- Propiedades de la imagen
	puntero.overOn("link")
	ID005VI.img_butt_norm:blend(crlx + 2,sdk.y + 54,id.trans_controls)
	if control.press("select") then
		sdk.getPropieties(id.path)
	end
end

end
-------------------------------------

---[[ FUNCIONES EXTRAS ]]--

function ID005VI.makePopup(id,archivo)
---element[ejem] = { texto = (nombre del elemento) , accion = (accion de la pulsacion) , est = (boleano que avilita/desavilita el elemento) }
toback = true
if files.ext(archivo) == "gif" then toback = false end

local eleme = {}

table.insert(eleme, { texto = getText("ver pantalla completa",ID005VI) , accion = "" , est = false })
table.insert(eleme, { texto = getText("establecer como fondo",ID005VI) , accion = "descktop.makeBackg(\""..archivo.."\")" , est = toback })
table.insert(eleme, { texto = getText("crear accs dir",ID005VI) , accion = "descktop.makeAccsDir(\""..string.lower(files.nopath(archivo)).."\",\"image\",\"".."FILE".."\",\""..archivo.."\")" , est = true })
table.insert(eleme, { texto = getText("abrir ubicacion",ID005VI) , accion = "launch.explorerFile(\""..archivo.."\")" , est = true , accionToClose = true})
table.insert(eleme, { texto = getText("perzonalizacion",ID005VI) , accion = "" , est = false })
table.insert(eleme, { texto = getText("a bitmap",ID005VI) , accion = "" , est = false })
table.insert(eleme, { texto = getText("propiedades",ID005VI) , accion = "sdk.getPropieties(\""..archivo.."\")" , est = true , accionToClose = true })

popup.setElements(eleme)
popup.activate()
end

function ID005VI.imgCenter(id)
if id.image == nil then return end

if id.imagen_w + sdk.x > sdk.w then id.imagen_x =  0 - ((id.imagen_w - sdk.w) / 2) else id.imagen_x = (sdk.w - id.imagen_w) / 2 end
if id.imagen_h + sdk.y > sdk.h then id.imagen_y =  0 - ((id.imagen_h - sdk.h) / 2) else id.imagen_y = (sdk.h - id.imagen_h) / 2 end

end

function ID005VI.loadBasic()
if files.exists("ms0:/picture") == false then return end

local list = files.listfiles("ms0:/picture")
table.sort(list,ID005VI.ordenador)
if table.maxn(list) == 0 then return end

dev = nil

for i = 1,table.maxn(list) do
	ext = files.ext(list[i].name)
	if ext == "png" or ext == "jpg" or ext == "gif" then
		dev = list[i].name
		break
	end
end

return dev
end

function ID005VI.changeNext(id)
if id.path == nil then return end

local last = id.path

local path = files.nofile(id.path)

local lista = files.listfiles(path)

if table.maxn(lista) == 0 then return end
table.sort(lista,ID005VI.ordenador)

local list = {}

for i = 1,#lista do
	local ext = files.ext(lista[i].name)
	if ext == "png" or ext == "jpg" or ext == "gif" then 
		table.insert(list,lista[i])
	end
end

if table.maxn(list) == 0 then return end

table.sort(list,ID005VI.ordenador)

if table.maxn(list) == 0 then return end

local pasado = false
local ante = id.path

for i = 1,table.maxn(list) do
	if pasado == true then 
		ext = files.ext(list[i].name)
		if ext == "png" or ext == "jpg" or ext == "gif" then
			ante = list[i].name
			break
		end
	end
	
	if list[i].name == id.path then
		pasado = true
	end
end

if last == ante or last == nil then 
	id.path = list[1].name
	ID005VI.loadImage(id)
	return 
end

id.path = ante

ID005VI.loadImage(id)

end


function ID005VI.changeLast(id)
if id.path == nil then return end

local path = files.nofile(id.path)

local lista = files.listfiles(path)

if table.maxn(lista) == 0 then return end
table.sort(lista,ID005VI.ordenador)

local list = {}

for i = 1,#lista do
	local ext = files.ext(lista[i].name)
	if ext == "png" or ext == "jpg" or ext == "gif" then 
		table.insert(list,lista[i])
	end
end

if table.maxn(list) == 0 then return end

local last = 0
local pasado = false

for i = 1,table.maxn(list) do
	if list[i].name == id.path then
		last = i
		break
	end	
end

last = last - 1

if last == 0 then 
	id.path = list[#list].name
	ID005VI.loadImage(id)
	return 
end

id.path = list[last].name

ID005VI.loadImage(id)

end


function ID005VI.loadImage(id)

if id.path == nil then return end

if files.exists(id.path) == false then
	id.path = nil
	return
end

local ext = files.ext(id.path)
if ext == "png" or ext == "jpg" or ext == "gif" then else
	id.path = nil
	return 
end

if id.image ~= nil then
	id.image:free()
end

id.image = image.load(id.path)

id.imagen_w = id.image:width()
id.imagen_h = id.image:height()
id.imagen_x = 0
id.imagen_y = 0
id.imagen_fs = 100
id.escala = 100

ID005VI.imgCenter(id)

if id.imagen_w > sdk.w or id.imagen_h > sdk.h then
	if id.blitmode == "scale" then
		ID005VI.reescaleIMG(id)
	else
		if id.blitmode == "extend" then
			ID005VI.expandedIMG(id)
		else
			ID005VI.loadFullImage(id)
		end

	end
end

collectgarbage("collect")
end

function ID005VI.reescaleIMG(id)
id.escala = 100
local ext = files.ext(id.path)

if (id.imagen_w * id.imagen_h) > (512 * 512) then
	ID005VI.loadFullImage(id)
	return
end

for i = 1,100 do
id.escala = 100 - i

local w = (id.imagen_w / 100) * id.escala
local h = (id.imagen_h / 100) * id.escala

if w <= sdk.w and h <= sdk.h then
	break
end

end

id.image:resize(math.floor((id.imagen_w / 100) * id.escala),math.floor((id.imagen_h / 100) * id.escala))
id.imagen_h = math.floor((id.imagen_h / 100) * id.escala)
id.imagen_w = math.floor((id.imagen_w / 100) * id.escala)

ID005VI.imgCenter(id)
end


function ID005VI.expandedIMG(id)
local ext = files.ext(id.path)

if (id.imagen_w * id.imagen_h) > (512 * 512) then
	ID005VI.loadFullImage(id)
	return
end

id.escala = "???"

id.image:resize(sdk.w - 2,sdk.h - 2)
id.imagen_h = sdk.h - 2
id.imagen_w = sdk.w - 2

ID005VI.imgCenter(id)
end

function ID005VI.loadFullImage(id)

if id.imagen_w > sdk.w or id.imagen_h > sdk.h then
	id.image:resize(sdk.w,sdk.h)
	
	if id.tmp ~= nil then id.tmp:free() end
	
	if files.ext(id.path) == "gif" then
		id.tmp = image.create(sdk.w,sdk.h,color.new(0,0,0,0))
	else
		id.tmp = image.create(sdk.w,sdk.h,0x0)
	end
	
	local x = 0
	local y = 0
	
	if id.imagen_w + sdk.x > sdk.w then x =  0 - ((id.imagen_w - sdk.w) / 2) else x = (sdk.w - id.imagen_w) / 2 end
	if id.imagen_h + sdk.y > sdk.h then y =  0 - ((id.imagen_h - sdk.h) / 2) else y = (sdk.h - id.imagen_h) / 2 end

	id.tmp:blit(x,y,id.image)
	id.image = id.tmp
	
	id.imagen_x = 0
	id.imagen_y = 0
end

end

function ID005VI.ordenador(a,b)

if a.directory == b.directory then
	return a.name < b.name
end

return a.directory
end

function ID005VI.changemode(id)
	if id.blitmode == "scale" then
		id.blitmode = "full"
		id.cronoModo = crono
		ID005VI.loadImage(id)
		return
	end
	
	if id.blitmode == "full" then
		id.blitmode = "extend"
		id.cronoModo = crono
		ID005VI.loadImage(id)
		return
	end
	
	if id.blitmode == "extend" then
		id.blitmode = "scale"
		id.cronoModo = crono
		ID005VI.loadImage(id)
		return
	end
end