ID009FE.cfg_.title = "FISHELL File Extractor 1.0"
ID009FE.cfg_.title_for_accs = "File Extractor"
ID009FE.cfg_.multiLoad = true
ID009FE.path = "ms0:/FISHELL/APP/ID009FE"
---------------------------------------------------------------
---------------------------------------------------------------

ID009FE.img_rar = image.load(ID009FE.path.."/src/img/rar.png")
ID009FE.img_zip = image.load(ID009FE.path.."/src/img/zip.png")
ID009FE.img_unk = image.load(ID009FE.path.."/src/img/unknown.png")

function ID009FE.init(id,input)
	id.TF_Input = sdk.textfield.new(5,20,400)
	id.TF_Input.enabled = false
	id.TF_Output = sdk.textfield.new(5,60,400)
	id.TF_Input_pass = sdk.textfield.new(5,100,85)
	id.TF_Input_pass.enabled = false
	
	id.btt_srcInput = sdk.button.new(id,ID009FE.seleccionarArchivoA,"",ID009FE.path.."/src/img/src.png")
	id.btt_srcOutput = sdk.button.new(id,ID009FE.seleccionarDestinoA,"",ID009FE.path.."/src/img/src.png")
	
	id.rb_overwrite = sdk.r_button.new(true,"Sobreescribir archivos existentes")
	id.rb_openfile = sdk.r_button.new(true,"Abrir directorio despues de extraer")
	id.rb_password = sdk.r_button.new(false,"Utilizar clave")
	
	id.file_icon = ID009FE.img_unk
	id.file_name = "[SELECCIONA UN ARCHIVO]"
	
	id.btt_extract = sdk.button.new(id,ID009FE.extraerArchivo,"Extraer Archivos")
	
	if input ~= nil then
		ID009FE.procesarArchivo(id,input)
	end
end

function ID009FE.run(id)
	sdk.cristalEffect(2,sdk.h - 48,459,46,70)
	screen.print(sdk.x + 5,sdk.y + 10,"Archivo rar|zip de origen:",0.5,color.new(40,40,40),color.new(250,250,250,200))
	sdk.textfield.draw(id.TF_Input)
	screen.print(sdk.x + 5,sdk.y + 50,"Destino de los archivos descomprimidos:",0.5,color.new(40,40,40),color.new(250,250,250,200))
	sdk.textfield.draw(id.TF_Output)
	screen.print(sdk.x + 5,sdk.y + 89,"Clave de acceso [Opcional]: ",0.5,color.new(40,40,40),color.new(250,250,250,200))
	sdk.textfield.draw(id.TF_Input_pass)
	
	sdk.button.draw(id.btt_srcInput,9 + 400,19)
	sdk.button.draw(id.btt_srcOutput,9 + 400,59)
	
	sdk.button.draw(id.btt_extract,340,sdk.h - 22)
	
	sdk.r_button.draw(id.rb_overwrite,3,85 + 40)
	sdk.r_button.draw(id.rb_openfile,245,85 + 40)
	sdk.r_button.draw(id.rb_password,100,101)
	
	ID009FE.divujarPaleta(id)
	
	id.TF_Input_pass.enabled = id.rb_password.value
end

function ID009FE.exit(id) --[[ Aqui se coloca lo que se ejecutar al finalizar la aplicacion (se pueden liberar elementos individuales) ]]--

end

function ID009FE.free() --[[ Aqui se liberan los recursos que fueron requeridos (se eliminan los elementos GLOBALES) ]]--

end

function ID009FE.seleccionarArchivoA(id)
	FILE_SELECTOR_TYPE = "files"
	FILE_SELECTOR_FILTER = { "rar" , "zip" }
	FILE_SELECTOR_NAME_FILTER = "Archivos comprimidos ( RAR | ZIP )"
	
    local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil or files.exists(ruta) == false then return end
	
	ID009FE.procesarArchivo(id,ruta)
end

function ID009FE.seleccionarDestinoA(id)
	FILE_SELECTOR_ROOT_ENABLED = true
	FILE_SELECTOR_TYPE = "folders"
	FILE_SELECTOR_NAME_FILTER = "Ruta de destino"
	
	 local ruta = system.runPortal("ms0:/FISHELL/SRC/PORTAL/FILE_SELECTOR")
	
	if ruta == nil or files.exists(ruta) == false then return end
	
	id.TF_Output.text = ruta
end

function ID009FE.procesarArchivo(id,ruta)
	local ext = files.ext(ruta)
	
	if ext == "rar" or ext == "zip" then
	else
		system.mensaje("Error","","Archivo no valido (Extencin no reconocida)")
		return
	end

	if files.exists(ruta) == false then
		system.mensaje("Error","","El archivo que desea abrir no existe")
		return
	end
	
	if ext == "rar" then
		id.file_icon = ID009FE.img_rar
	else
		id.file_icon = ID009FE.img_zip
	end
	
	id.file_path = ruta
	id.file_name = files.nopath(ruta)
	id.file_to_path = string.sub(id.file_name,1,#id.file_name - 4)
	id.file_to_path = files.nofile(ruta)..id.file_to_path.."/"
	
	id.TF_Input.text = ruta
	id.TF_Output.text = id.file_to_path
end

function ID009FE.divujarPaleta(id)
	id.file_icon:blit(sdk.x + 4,177 - 7)
	screen.print(sdk.x + 59,177 + 4,id.file_name,0.55,color.new(0,0,0),color.new(255,255,255,180))
	
	if id.file_name == "[SELECCIONA UN ARCHIVO]" then
		screen.print(sdk.x + 59,177 + 16,"Tipo de archivo: [unknown]",0.55,color.new(0,0,0),color.new(255,255,255,180))
	else
		screen.print(sdk.x + 59,177 + 16,"Tipo de archivo: "..files.ext(id.file_name),0.55,color.new(0,0,0),color.new(255,255,255,180))
	end
end

function ID009FE.extraerArchivo(id)
	local destino = sdk.textfield.getText(id.TF_Output)
	local origen = id.file_path

	
	if destino == nil or origen == nil or files.exists(origen) == false then 
		return 
	end
	
	local input = "aorigen = '"..origen.."'; adestino = '"..destino.."'; "
	local tipo = files.ext(origen)
	
	if tipo ~= "rar" and tipo ~= "zip" then
		return
	end
	
	system.printLabel("load","")
	
	if files.exists(destino) == false then
		files.mkdir(destino)
		if files.exists(destino) == false then
			system.mensaje("El destino no existe","","")
		end
	end
	
	files.copy(ID009FE.path.."/src/doc/un"..tipo..".lua","ms0:/FISHELL/LHM/lib/id009fe_"..tipo..".lua",true,true)
	
	system.closeLabel()
	launch.lhms("id009fe_"..tipo..".lua",input)
end
