---- Modulo mouse para el manejo del puntero ----
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

if cfg == nil or cfg.cursor == nil then 
	if cfg == nil then
		cfg = {}
		cfg.joystick_enabled = true
		cfg.cursor_effect = true
	end
	
	cfg.cursor = "fishball"
end

puntero = { img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/normal.png"), x = 230 , y = 130 , vel = 4 }

puntero.interactive = {}
puntero.interactive[1] = { img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/link.png") , trans = 0 }
puntero.interactive[2] = { img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/popup.png") , trans = 0 }
puntero.interactive[3] = { img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/popup_link.png") , trans = 0 }
puntero.interactive[4] = { trans = 0 }
puntero.interactive[5] = { trans = 0 }

puntero.tp = {}
puntero.tp.trans = 0
puntero.tp.texto = ""
puntero.tp.crono = 40
puntero.tp.isActual = true
puntero.isConversed = false

mouse_deadzone = 45
mouse_sensibility = 5
puntero.sens = 0

puntero.interactive_type = 0

if files.exists("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/cfg.txt") then
	dofile("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/cfg.txt");
else
	dofile("ms0:/FISHELL/CURSORS/default_cfg.txt");
end

function puntero.drive()

if app ~= nil and app.kernel_scroll_ == true then
	puntero.overOn("scroll")
	if cfg.joystick_enabled == true then
		controls.analogtodigital(60)
	else
		controls.analogtodigital(0)
	end
	
	puntero.isConversed = true
	return
else
	if puntero.isConversed == true then
		controls.analogtodigital(0)
		puntero.isConversed = false
	end
end

local analogymove = false

if cfg.joystick_enabled == true then

	if math.abs(controls.analogy()) > mouse_deadzone then 
		puntero.y = puntero.y + (controls.analogy()/100) * puntero.sens
		analogymove = true
	end
	
	if math.abs(controls.analogx()) > mouse_deadzone then 
		puntero.x = puntero.x + (controls.analogx()/100) * puntero.sens 
		analogymove = true
	end

	if analogymove == true then
		puntero.sens = puntero.sens + 0.30
		if puntero.sens > mouse_sensibility then
			puntero.sens = mouse_sensibility
		end
	else
		puntero.sens = 0
	end
end

if controls.up() then puntero.y = puntero.y - puntero.vel end
if controls.down() then puntero.y = puntero.y + puntero.vel end
if controls.right() then puntero.x = puntero.x + puntero.vel end
if controls.left() then puntero.x = puntero.x - puntero.vel end

if puntero.x <= 0 then puntero.x = 0 end
if puntero.x >= 480 then puntero.x = 479 end
if puntero.y <= 0 then puntero.y = 0 end
if puntero.y >= 272 then puntero.y = 271 end

end

function puntero.draw(trans)

if trans == nil then trans = 255 end

if trans < 255 then
puntero.interactive_type = 0
end

trans_ = trans

puntero.drive()

if puntero.interactive_type == 0 then
	for i = 1,#puntero.interactive do
		if i ~= puntero.interactive_type then 
			if cfg.cursor_effect == true then
				puntero.interactive[i].trans = puntero.interactive[i].trans - 8 
				if puntero.interactive[i].trans < 0 then puntero.interactive[i].trans = 0 end
			else
				puntero.interactive[i].trans = 0
			end
		end
	end
else
	for i = 1,table.maxn(puntero.interactive) do
		if i ~= puntero.interactive_type then 
			if cfg.cursor_effect == true then
				puntero.interactive[i].trans = puntero.interactive[i].trans - 8 
				if puntero.interactive[i].trans < 0 then puntero.interactive[i].trans = 0 end
			else
				puntero.interactive[i].trans = 0
			end
		end
		
	end
	
	if cfg.cursor_effect == true then
		puntero.interactive[puntero.interactive_type].trans = puntero.interactive[puntero.interactive_type].trans + 8
	else
		puntero.interactive[puntero.interactive_type].trans = 255
	end
	
	
	if puntero.interactive[puntero.interactive_type].trans > 255 then
		puntero.interactive[puntero.interactive_type].trans = 255
	end
	
	trans_ = trans_ - (puntero.interactive[puntero.interactive_type].trans + 15)
end

local px
local py

if puntero.interactive_type ~= 0 then
	px = puntero.interactive[puntero.interactive_type].px
	py = puntero.interactive[puntero.interactive_type].py
else
	px = puntero.px
	py = puntero.py
end

if trans_ < 0 then 
	trans_ = 0
else
	puntero.img:blend(puntero.x - px,puntero.y - py,trans_ + 50)
end

for i = 1,table.maxn(puntero.interactive) do
	if puntero.interactive[i].trans > 0 then
		puntero.interactive[i].img:blend(puntero.x - px,puntero.y - py,puntero.interactive[i].trans)
	end
end

if puntero.interactive_type ~= 0 then puntero.interactive_type = 0 end
end

function puntero.setVel(vel) 
mouse_sensibility = vel
end

function puntero.isOver(x,y,w,h)
	return uld.isOver(x,y,w,h,puntero.x,puntero.y)
end

function puntero.resetVel(vel) 
puntero.vel= 3
mouse_sensibility = 6
end

function puntero.overOn(tipo)
if tipo == nil then  puntero.interactive_type = 0 end
if tipo == "link" then puntero.interactive_type = 1 end
if tipo == "popup" then puntero.interactive_type = 2 end
if tipo == "popup_link" then puntero.interactive_type = 3 end
if tipo == "textfield" then puntero.interactive_type = 4 end
if tipo == "scroll" then puntero.interactive_type = 5 end
end

function puntero.toolTip(texto)

end

