--[[ Documentacion para el modulo osk ]]--
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com

osk = {}
osk.cronob = 40
osk.cronoi = 20

function osk.load()
	---- FUNCIONES QUE CARGAN EL OSK
	osk.img_window = image.load("ms0:/FISHELL/IMG/OSK/window.png")
	osk.img_plantilla = image.load("ms0:/FISHELL/IMG/OSK/plantilla.png")
	osk.img_foco = image.load("ms0:/FISHELL/IMG/OSK/focus.png")
	osk.font = font.load("ms0:/FISHELL/FONTS/fish_2.pgf")
	plantilla = {}
	
	plantilla[1] = {
		"1" , "2" , "3" , "4" , "5" , "6" , "7" , "8" , "9" , "0",
		
		"q" , "w" , "e" , "r" , "t" , "y" , "u" , "i" , "o" , "p",
		"a" , "s" , "d" , "f" , "g" , "h" , "j" , "k" , "l" , "",
		"z" , "x" , "c" , "v" , "b" , "n" , "m" , "," , "." , "-",
	}
	
	plantilla[2] = {
		"!" , "\"" , "#" , "$" , "%" , "&" , "/" , "(" , ")" , "=",
		
		"Q" , "W" , "E" , "R" , "T" , "Y" , "U" , "I" , "O" , "P",
		"A" , "S" , "D" , "F" , "G" , "H" , "J" , "K" , "L" , "",
		"Z" , "X" , "C" , "V" , "B" , "N" , "M" , ";" , ":" , "_",
	}
	
	plantilla[3] = {
		"1" , "2" , "3" , "4" , "5" , "6" , "7" , "8" , "9" , "0",
		
		"[" , "]" , "{" , "}" , "?" , "" , "|" , "!" , "" ,  "",
		"" , "" , "" , "" , "" , ""  , "+" , "-" , "/" , "=",
		"." , "_" , "," , ";" , ":" , "*" , "<" , ">" , ""  ,  "",
	}
	 
	opciones = {}
	opciones[1] = {name = getText("cancelar txt osk") , chunk = "osk.cancel()" }
	opciones[2] = {name = getText("osk copiar al pp") , chunk = "osk.copytext()" }
	opciones[3] = {name = getText("osk pegar texto") , chunk = "osk.pastetext()" }
	opciones[4] = {name = getText("pasar al osk oficial") , chunk = "system.printLabel('03','Espere...'); osk.texto = os.osk('osk original',osk.texto,300,10,0); osk.caretpos = #osk.texto; system.closeLabel()" }
	opciones[5] = {name = getText("borrar campo osk") , chunk = "osk.texto = ''; osk.caretpos = 0" }
	
	if control == nil then
		system.dofile("ms0:/FISHELL/SRC/drives.lua")
	end
end

function osk.getText(titulo,comienzo,maxchar)
	osk.img_screen = screen.toimage()
	
	if cfg ~= nil and cfg.joystick_enabled == true then
		controls.analogtodigital(60)
	else
		controls.analogtodigital(0)
	end
	
	osk.titulo = titulo
	
	if osk.img_window == nil then
		system.printLabel("03",getText("cargando osk"))
		osk.load()
		system.closeLabel()
	end
	
	osk.close = false
	
	if comienzo == nil or comienzo == "" then
		comienzo = ""
		osk.texto = ""
	else
		osk.texto = comienzo
	end
	
	osk.plantilla = 1
	osk.focuspos = 11
	osk.caretpos = #comienzo
	osk.eftitulo = 21 + 20
	
	for i = 0,255,13 do
		osk.draw(i)
	end
	
	while true do
		osk.draw()
		if osk.close == true then break end
	end
	
	for i = 255,0,-13 do
		osk.draw(i)
	end
	
	osk.draw(0)
	
	controls.analogtodigital(0)
	if kernel ~= nil then kernel.postImage(osk.img_screen) end
	osk.free()
	return osk.texto 
end

function osk.draw(trans)
	if trans == nil then trans = 255 end
	osk.img_screen:blit(0,0)
	osk.img_window:blend(21,15,trans)
	osk.dibujarplantilla(trans)
	
	if osk.texto ~= nil then
		screen.print(21 + 18,15 + 18,osk.texto,0.55,color.new(0,0,0,trans),color.new(255,255,255,trans - 50))
	end
	
	if osk.cronob > 0 and osk.texto ~= nil then
		screen.print(21 + 18 + screen.textwidth(string.sub(osk.texto,1,osk.caretpos)),15 + 18.5,"|",0.55,color.new(0,0,0,trans),color.new(255,255,255,trans - 50))
		osk.cronob = osk.cronob - 1
		if osk.cronob <= 0 then 
			osk.cronob = 0 
			osk.cronoi = 20
		end
	else
		osk.cronoi = osk.cronoi - 1
		if osk.cronoi <= 0 then 
			osk.cronob = 50
			osk.cronoi = 0
		end
	end
	
	osk.eftitulo = screen.print(osk.eftitulo,19 + 210,osk.titulo,0.5,color.new(0,0,0,trans),color.new(255,255,255,trans - 50),"scroll_left",390)
	
	screen.flip()
	if trans ~= 255 then return end
	osk.lecturacontroles()
end

function osk.dibujarplantilla(trans)
	osk.img_plantilla:blend(21 + 86,15 + 56,trans)
	
	for i = 1,10 do
		local x = 21 + 86 + ((i - 1) * 33)
		local y = 15 + 56
		osk._divujarletra(x,y,plantilla[osk.plantilla][i],trans,i)
	end
	
	for i = 11,20 do
		local x = 21 + 86 + ((i - 11) * 33)
		local y = 15 + 102
		
		osk._divujarletra(x,y,plantilla[osk.plantilla][i],trans,i)
	end
	
	for i = 21,30 do
		local x = 21 + 86 + ((i - 21) * 33)
		local y = 15 + 102 + 33
		
		osk._divujarletra(x,y,plantilla[osk.plantilla][i],trans,i)
	end
	
	for i = 31,40 do
		local x = 21 + 86 + ((i - 31) * 33)
		local y = 15 + 102 + 66
		
		osk._divujarletra(x,y,plantilla[osk.plantilla][i],trans,i)
	end
end

function osk._divujarletra(x,y,letra,trans,i)

	if osk.focuspos == i then
		osk.img_foco:blend(x,y,trans)
		draw.rect(x,y,30,30,color.new(0,0,0,trans))
	end
	
	uld.printCenter(x,y + 10,letra,0.7,color.new(30,30,30,trans),color.new(185,185,185,trans),30)
end

function osk.lecturacontroles()
	if controls.press("up") then
		osk.cronob = 40
		osk.focuspos = osk.focuspos - 10
		if osk.focuspos <= 0 then osk.focuspos = osk.focuspos + 40 end
	end
	
	if controls.press("down") then
		osk.cronob = 40
		osk.focuspos = osk.focuspos + 10
		if osk.focuspos > 40 then osk.focuspos = osk.focuspos - 40 end
	end
	
	if controls.press("left") then
		osk.cronob = 40
		osk.focuspos = osk.focuspos - 1
		if osk.focuspos == 0 then osk.focuspos = 10 
		elseif osk.focuspos == 10 then osk.focuspos = 20 
		elseif osk.focuspos == 20 then osk.focuspos = 30
		elseif osk.focuspos == 30 then osk.focuspos = 40
		end
	end
	
	if controls.press("right") then
		osk.cronob = 40
		osk.focuspos = osk.focuspos + 1
		if osk.focuspos == 41 then osk.focuspos = 31 
		elseif osk.focuspos == 11 then osk.focuspos = 1 
		elseif osk.focuspos == 21 then osk.focuspos = 11
		elseif osk.focuspos == 31 then osk.focuspos = 21
		end
	end
	
	if controls.press("select") then
		osk.plantilla = osk.plantilla + 1
		if osk.plantilla > #plantilla then
			osk.plantilla = 1
		end
	end
	
		controls.read()
	
	if controls.press("cross") then
		osk.write(plantilla[osk.plantilla][osk.focuspos])
	end
	
	if controls.press("square") then
		osk.drop()
	end
	
	if controls.press("triangle") then
		osk.write(" ")
	end
	
	if controls.press("l") then
		osk.caretpos = osk.caretpos - 1
		if osk.caretpos <= 0 then osk.caretpos = 0 end
	end
	
	if controls.press("r") then
		osk.caretpos = osk.caretpos + 1
		if osk.caretpos >= #osk.texto then osk.caretpos = #osk.texto end
	end
	
	if controls.press("start") then
		osk.close = true
	end
	
	if controls.press("circle") then
		drawactions()
	end
end

function osk.write(letra)	
	if osk.caretpos == #osk.texto then
		osk.texto = osk.texto..letra
		osk.caretpos = #osk.texto
		return
	end
	
	if osk.caretpos < #osk.texto then
		osk.texto = string.sub(osk.texto,1,osk.caretpos)..letra..string.sub(osk.texto,osk.caretpos + 1,#osk.texto)
		osk.caretpos = osk.caretpos + 1
		return
	end
end

function osk.drop()
	if osk.caretpos == 0 then return end
	osk.texto = string.sub(osk.texto,1,osk.caretpos - 1)..string.sub(osk.texto,osk.caretpos + 1,#osk.texto)
	osk.caretpos = osk.caretpos - 1
end

function osk.free()
	---- LIVERA LOS RECURSOS DEL OSK
	osk.img_window:free()
	osk.img_screen:free()
	osk.img_plantilla:free()
	plantilla = nil
	osk.font:free()
	osk.img_foco:free()
	osk.img_window = nil
	osk.close = nil
	osk.comienzo = nil
	collectgarbage("collect")
end

function drawactions()
	osk.actions = {}
	osk.actions.screen = screen.toimage()
	osk.actions.posy = 0 - (#opciones * 10)
	osk.actions.isclose = false
	osk.actions.foco = 1
	osk.actions.img_panel = image.create(200,(#opciones * 10) + 10,color.new(220,220,220))
	while true do
		drawpanelactions()
		if osk.actions.isclose == true and osk.actions.posy <= 0 - (#opciones  * 10) then
			return false
		end
	end
	osk.actions.screen:blit(0,0)
	screen.flip()
end

function drawpanelactions()
	if osk.actions.isclose == true then
		osk.actions.posy = osk.actions.posy - 2
	else
		osk.actions.posy = osk.actions.posy + 2
	end
	
	if osk.actions.posy > 0 then osk.actions.posy = 0 end
	if osk.actions.posy < 0 - (#opciones * 10) then osk.actions.posy = 0 - (#opciones * 10) end
	
	osk.actions.screen:blit(0,0)
	osk.actions.img_panel:blit(0,osk.actions.posy)
	draw.rect(-1,osk.actions.posy - 1,200,(#opciones * 10) + 10,color.new(0,0,0))
	
	for i = 1,#opciones do
		local x = 5
		local y = osk.actions.posy + 3 + ((i - 1) * 10)
		if osk.actions.foco == i then
			draw.fillrect(x - 2,y,193,11,color.new(130,130,130,170))
		end
		screen.print(x,y,opciones[i].name,0.5,color.new(0,0,0),color.new(255,255,255))
	end
	screen.flip()
	controls.read()
	if osk.actions.posy ~= 0 then return end
	
	if control.press("back") then
		osk.actions.isclose = true
	end
	if controls.press("up") then
		osk.actions.foco = osk.actions.foco - 1
		if osk.actions.foco <= 0 then osk.actions.foco = #opciones end
	end
	if controls.press("down") then
		osk.actions.foco = osk.actions.foco + 1
		if osk.actions.foco > #opciones then osk.actions.foco = 1 end
	end
	
	if control.press("select") then
		assert(loadstring(opciones[osk.actions.foco].chunk))();
		osk.actions.isclose = true
	end
end

function osk.copytext()
	if kernel == nil then return end
	kernel.portapapeles = tostring(osk.texto)
end

function osk.pastetext()
	if kernel == nil then return end
	if kernel.portapapeles == nil or kernel.portapapeles == "" then return end
	osk.texto = osk.texto..kernel.portapapeles
	osk.caretpos = #osk.texto
end

function osk.cancel()
	osk.texto = nil
	osk.close = true
end