--[[ Modulo APP Manager ]] --
--[[ Gestiona las ventanas del shell (Abrir, Cerrar, Minimizar, Enfocar) ]]--
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com


app = {} 
app.img_blackscreen = image.create(463,198,color.new(0,0,0))

app.trans_blackscreenB = 255
app.closeOtherWindow = false

app.desenfocando = false
app.efectoDesenfoque = nil
app.tmp_screen = nil
app.window_rage = false
app.window_rage_X = 0
app.windows_limit = 8		--- Limite de ventanas abiertas
app.wtb_x = 0		--- Posicion de la paleta de botones de la ventana (Window Table Buttons)
app.wtb_y = -20		--- Posicion de la paleta de botones de la ventana (Window Table Buttons)

app.id_reiniciado = nil

--[[ Funciones ADMINISTRATIVAS del modulo app manager ]]--

--- app.load([String] ID (ID de la aplicacion en ms0:/FISHELL/APP) , [String | Number | Table] input (Argumento pasado a la aplicacion al abrirse) )

function app.load(ID,input) --- Carga una aplicacion

if table.maxn(fishbar.apps) >= app.windows_limit then system.mensaje(getText("advertencia"),"",getText("no se pueden abrir mas pestaas")); return end -- limite de 8 ventanas (por el espacio en la fishbar)
if fishbar.panel_activado == true then return end --- no permite abir aplicaciones nuevas si el menu principal esta activado

app_input = input -- Hace global el input para esta aplicacion

if fishbar.apps_focus ~= 0 then  ---Esto es para aplicar el efecto del desenfoque de la ventana anterior (en caso de que este enfocada alguna)
	if input == nil then
		app.desenfocar("app.de.load(\""..ID.."\")") 
	else
		app.desenfocar("app.de.load(\""..ID.."\",app_input)") 
	end
	return
end

--[[ Cargando datos y configutaciones en el app_manager ]]--

if files.exists("ms0:/FISHELL/APP/"..ID.."/app.lua") == false and files.exists("ms0:/FISHELL/APP/"..ID.."/app.lue") == false then 
	system.mensaje(getText("error"),"",getText("la app no existe"))
	return 
end

if files.exists("ms0:/FISHELL/APP/"..ID.."/loading.png") and app.getNumIDs(ID) == 0 then
	system.printLabel("ms0:/FISHELL/APP/"..ID.."/loading.png","")
else
	if files.exists("ms0:/FISHELL/APP/"..ID.."/load.png") then
		system.printLabel("ms0:/FISHELL/APP/"..ID.."/load.png","")
	else
		system.printLabel("load","")
	end
end

collectgarbage("collect") --- liberando la ram para hacer espacio para el nuevo programa

if sdk == nil then system.dofile("ms0:/FISHELL/SRC/SDK/app.lua") end --- Cargamos la SDK de programacion (en caso de que no este cargada)
if app.img_window == nil then app.loadInterfaceKit() end --- Cargamos el kit de la interface de las ventanas y sus funciones

local IDI 

if app.getNumIDs(ID) <= 0 then 
	assert(loadstring(ID.." = {}"))(); 					--- Inicializando tabla de datos (id) de la aplicacion
	assert(loadstring(ID..".cfg_ = {}"))(); 			--- Inicializando tabla de configuraciones de aplicacion
	app.loadLanguage(ID)								--- Cargando script de lenguage
	
	system.dofile("ms0:/FISHELL/APP/"..ID.."/app.lua") 	--- Cargando script de la aplicacion
	
else
	assert(loadstring("multiload = "..ID..".cfg_.multiLoad"))();
	if multiload == false then
		IDI = fishbar.apps[app.getFirstIndex(ID)].IDI
		
		if input == nil then
			assert(loadstring("if "..ID..".reinit ~= nil then "..ID..".reinit("..IDI..") end"))();
		else
			assert(loadstring("if "..ID..".reinit ~= nil then "..ID..".reinit("..IDI..",app_input) end"))();
		end
		
		system.closeLabel()
		app.enfocar(app.getFirstIndex(ID))
		return
	end
end

local NIDI = app.getNextSIDI(ID) -- Obtenemos el siguente subindice para esta id (indice del IDI)
local IDI = ID.."["..NIDI.."]" --- IDI de la aplicacion con su id como nombre e index de referencia como argumento ejm: ID001EA[3] (ventana num. 3 de la aplicacion ID001EA)
local SIDI = tostring(IDI)  --- SIDI es el IDI pasado a String 

assert(loadstring(IDI.." = {}"))(); --- Creamos la idi (como tabla) de la nueva aplicacion

--[[ Cargando variables de la ventana ]]--

fishbar.objh = fishbar.objh + 37 -- Acrecentando fishbar para abrir espacio a la aplicacion

local next_id = #fishbar.apps + 1

assert(loadstring("cfg_ = "..ID..".cfg_"))();

fishbar.apps[next_id] = { 

	id = ID ,  --- String con el ID de aplicacion 
	--index = NIDI , 
	index = app.getNumIDs(id) + 1 ,
	titulo = cfg_.title , --- String con el tituo de la aplicacion
	trans = 0 ,
	fbh_trans = 0 ,
	fbh_lastp = nil ,
	cfg = cfg_ ,
	fbh_visible = false ,
	close = false ,
	minimize = false , --- Estado del minimizado de la aplicacion
	efect = { minim = 0 , focus = 0 } ,
	IDI = IDI ,  -- Tabla con las variables internas del id de aplicacion
	SIDI = SIDI , -- String del IDI
	NUMIDI = NIDI  -- Number del index del IDI
	
	}
	
fishbar.apps[next_id].path = "ms0:/FISHELL/APP/"..ID
assert(loadstring(IDI..".this = fishbar.apps["..next_id.."]"))(); --- establece coneccion de la data en la fishbar con el metodo this de la id del programa a abrir
assert(loadstring(ID..".init("..IDI..",app_input)"))(); --- Lanza la funcion init() de la aplicacion

if files.exists("ms0:/FISHELL/APP/"..ID.."/icon.png") then
	fishbar.apps[next_id].icon = image.load("ms0:/FISHELL/APP/"..ID.."/icon.png")
else
	fishbar.apps[next_id].icon = fishbar.img_noIcono
end

app_input = nil

system.closeLabel()

-- system.mensaje("ID: "..ID,"","SIDI: "..SIDI)

descktop.focoin = "window" -- establece el foco en la ventana
fishbar.apps_focus = next_id 
sdk.restartX()

end

function app.open(ID,input) --- Otra forma de abrir una aplicacion
	app.load(ID,input)
end

function app.close(index) --- cierra una aplicacion (con el indice referente a la fishbar como argumento)

if fishbar.apps[index] == nil then return end

if index == fishbar.apps_focus then
	app.desenfocar("app.closeWindow("..index..")")
	fishbar.apps[index].close = true
	fishbar.apps[index].fbh_visible = false
	app.trans_blackscreenB = 255
else
	app.closeOtherWindow = true
	fishbar.apps[index].close = true
	fishbar.apps[index].fbh_visible = false
	app.closeWindow(index)
end

end

function app.reinit(id)  --- Reinicia una aplicacion
	app.id_reiniciado = id
	app.closeAllIds(id)
end

function app.closeWindow(index) --- funcion interna que finaliza la aplicacion y libera memoria (no se nesesita ejecutar manualmente)

if fishbar.apps[index] == nil then return end

fishbar.objh = fishbar.objh - 37

fishbar.apps[index].icon:free()

local SIDI = fishbar.apps[index].SIDI
local id = fishbar.apps[index].id

local ultimate = false  		--- Variable que indica si es la ultima aplicacion a cerrar con el mismo id

if app.getNumIDs(id) <= 1 then
	assert(loadstring(id..".exit("..SIDI..")"))();
	assert(loadstring(id..".free()"))();
	assert(loadstring(SIDI.." = nil"))();
	assert(loadstring(id.." = nil"))();
	ultimate = true
else
	assert(loadstring(id..".exit("..SIDI..")"))();
	assert(loadstring(SIDI.." = nil"))();
	--assert(loadstring(SIDI.." = {}"))();
end

collectgarbage("collect")
table.remove(fishbar.apps,index)

sdk.restartX()

if app.id_reiniciado ~= nil and app.id_reiniciado == id and ultimate == true then
	app.id_reiniciado = nil
	app.load(id)
	return
end

if descktop.focoin == "window" then
	app.enfocar(app.getNextMaximize(index)) 
end

end

function app.getNumIDs(ID) -- retorna el numero de aplicaciones con el msmo id
if table.maxn(fishbar.apps) == 0 then return 0 end

local indexs = 0

for i = 1,#fishbar.apps do
	if fishbar.apps[i].id == ID then
		indexs = indexs + 1
	end
end

return indexs

end

function app.getNextSIDI(ID) -- retorna el numero del siguente SIDI de la aplicacion con el ID de argumento

	if #fishbar.apps == 0 then return 1 end
	if app.getNumIDs(ID) == 0 then return 1 end

	local nsidi = 1

	for i = 1,#fishbar.apps do
		if fishbar.apps[i].id == ID then
			nsidi = math.max(nsidi,fishbar.apps[i].NUMIDI + 1)
		end
	end

	return nsidi

end

function app.run(APP) -- corre la aplicacion con el IDI pasado como argumento (no se nesesita ejecutar manualmente)

if app.desenfocando == false then
	if APP.trans == 255 then 
		
		if APP.minimize == true then APP.minimize = false end
		app.trans_blackscreenB = app.trans_blackscreenB - 12
		if app.trans_blackscreenB < 0 then app.trans_blackscreenB = 0 end
		
		loadstring("EXM.try("..APP.id..".run"..",EXM.app_exception,"..APP.IDI..")")(); --- Corre el contenido de la aplicacion en modo a prueba de fallos
		
		if sdk.x ~= sdk.objx then 
			if sdk.objx > sdk.x then  if sdk.x + 5 >= sdk.objx then sdk.x = sdk.objx else sdk.x = sdk.x + 4 end end
			if sdk.objx < sdk.x then  if sdk.x - 5 <= sdk.objx then sdk.x = sdk.objx else sdk.x = sdk.x - 4 end end
		end
		
		if sdk.x < -5 and app.trans_blackscreenB == 0 then gadget.draw(APP.trans) end
		
		if app.trans_blackscreenB ~= 0 then app.img_blackscreen:blend(sdk.x,sdk.y,app.trans_blackscreenB) end
	end
else
	app.tmp_screen:blend(sdk.x,sdk.y,APP.trans)
end

draw.rect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(0,0,0,APP.trans)) 
end

function app.loadInterfaceKit() --- carga la interfaz de la ventana (no se nesesita ejecutar manualmente)

app.img_window = image.load(LOG_THEME_PATH.."CUSTOM/system/window/window.png") 
fishbar.img_fbh = image.load(LOG_THEME_PATH.."CUSTOM/system/window/fbh.png") 
fishbar.img_fbh2 = image.load(LOG_THEME_PATH.."CUSTOM/system/window/fbh2.png") 
fishbar.img_fbh_minimize = image.load(LOG_THEME_PATH.."CUSTOM/system/window/fbh_minimize.png") 
fishbar.img_noIcono = image.load(LOG_THEME_PATH.."CUSTOM/system/window/no_icon.png")

app.buttonsA = image.load(LOG_THEME_PATH.."CUSTOM/system/window/button_close.png")
app.buttonsB = image.load(LOG_THEME_PATH.."CUSTOM/system/window/button_minimize.png")
app.buttonsC = image.load(LOG_THEME_PATH.."CUSTOM/system/window/button_todesk.png")

puntero.interactive[4].img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/textfield.png")
puntero.interactive[5].img = image.load("ms0:/FISHELL/CURSORS/"..cfg.cursor.."/scroll.png")

app.window_brightnnes = brightness.new("blanco")  

app.img_blackscreen = app.makeScreenEfect()

if cfg.color_window ~= nil then
	app.img_window:blit(9,26,image.create(462,197,0x0),1,1,461,196)
else
	if cfg.color_window_back == nil then
		app.img_window:blit(9,26,image.create(462,197,color.new(255,255,255,cfg.window_opaque)),1,1,461,196)
	else
		app.img_window:blit(9,26,image.create(462,197,color.new(cfg.color_window_back.R,cfg.color_window_back.G,cfg.color_window_back.B,cfg.window_opaque)),1,1,461,196)
	end
end

end


function app.drawWindow(APP,modo) --- dibuja la ventana (El borde de la aplicacion) (no se nesesita ejecutar manualmente)

if app.desenfocando == true then
	modo = -9
	if APP.trans <= 0 then 
		app.aedd(); return 
	end
end

if descktop.focoin == "escritorio" and APP.trans <= 0 then return end

APP.trans = APP.trans + modo
if APP.trans > 255 then APP.trans = 255 end
if APP.trans < 0 then APP.trans = 0 end

if puntero.isOver(sdk.x - 7,sdk.y - 22,sdk.w,21) and APP.close == false and APP.trans == 255 then
	brightness.draw(app.window_brightnnes,puntero.x - 50,-35,6)
	if control.press("select") then
		app.window_rage = true
		app.window_rage_X = puntero.x
		app.window_rage_first = puntero.x
	end
else
	brightness.draw(app.window_brightnnes,brightness.getX(app.window_brightnnes),-40,-6)
end

if cfg.color_window == nil then
	app.img_window:blend(sdk.x - 8,sdk.y - 25,APP.trans)
else
	image.fxtint(sdk.x - 8,sdk.y - 25,app.img_window,color.new(cfg.color_window.R,cfg.color_window.G,cfg.color_window.B,APP.trans))
	if APP.trans == 255 then
		if cfg.color_window_back == nil then
			draw.fillrect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(255,255,255,cfg.window_opaque))
		else
			draw.fillrect(sdk.x,sdk.y,sdk.w,sdk.h,color.new(cfg.color_window_back.R,cfg.color_window_back.G,cfg.color_window_back.B,cfg.window_opaque))
		end
	end
end

app.drawWindButtons(APP.trans) -- Dibujamos la paleta de botones de ventanas

screen.print(sdk.x + 75,sdk.y - 20 + 5,APP.titulo,0.55,color.new(40,40,40,APP.trans),color.new(255,255,255,APP.trans),"scroll_left",360)

if APP.trans ~= 255 and app.desenfocando == false then 
	app.img_blackscreen:blend(sdk.x,sdk.y,APP.trans)
end

if APP.crash == true then return end

app.run(APP) --- Corre el contenido del programa con el IDI pasado como argumento

end

function app.drawWindButtons(trans) --- Dibuja la paleta de botones de ventanas
	app.buttonsA:blend(sdk.x + app.wtb_x     ,sdk.y + app.wtb_y,trans - 150)
	app.buttonsB:blend(sdk.x + app.wtb_x + 23,sdk.y + app.wtb_y,trans - 150)
	app.buttonsC:blend(sdk.x + app.wtb_x + 46,sdk.y + app.wtb_y,trans - 150)
	
if uld.isOver(sdk.x + app.wtb_x,sdk.y + app.wtb_y,20,17,puntero.x,puntero.y) and app.desenfocando == false and trans == 255 then 
	puntero.overOn("link")
	app.buttonsA:blend(sdk.x + app.wtb_x,sdk.y + app.wtb_y,trans)
	
	if control.press("select") and sdk.x == 8 then
		app.close(fishbar.apps_focus) 
	end
end

if puntero.isOver(sdk.x + app.wtb_x + 23,sdk.y + app.wtb_y,20,17) and app.desenfocando == false and trans == 255 then
	app.buttonsB:blend(sdk.x + app.wtb_x + 23,sdk.y + app.wtb_y,trans)
	puntero.overOn("link")
	if control.press("select") and sdk.x == 8 then
		sdk.x = 8
		app.minimize(fishbar.apps_focus) 
	end
end

if puntero.isOver(sdk.x + app.wtb_x + 46,sdk.y + app.wtb_y,20,17) and app.desenfocando == false and trans == 255 then
	app.buttonsC:blend(sdk.x + app.wtb_x + 46,sdk.y + app.wtb_y,trans)
	puntero.overOn("link")
	if control.press("select") and sdk.x == 8 then
		sdk.x = 8
		app.desenfocar()
	end
end
end

function app.aedd()  --- aplica la funcion que continua el efecto de desenfoque
app.desenfocando = false
fishbar.apps_focus = 0
app.trans_blackscreenB = 255
if app.efectoDesenfoque ~= nil then assert(loadstring(app.efectoDesenfoque))(); end
if app.tmp_screen ~= nil then app.tmp_screen:free() end
sdk.restartX()
end

function app.screenToImage() ---- retorna una captura del programa visualisado
	img = image.create(sdk.w,sdk.h,color.new(0,0,0,0))
	img:blit(0 - sdk.x,0 - sdk.y,screen.toimage())
	return img
end

function app.makeScreenEfect() ---- obtiene una imagen del escritorio y la ventana en la posicion de la aplicacion
	img = image.create(sdk.w,sdk.h,0x0)
	img:blit(0 - sdk.x,0 - sdk.y,app.img_window)
	return img
end

function app.enfocarActual() ---- enfoca la aplicacion actual (en caso de que no este enfocada) (no se nesesita ejecutar manualmente)
	if fishbar.apps_focus == 0 then return end
	descktop.focoin = "window"
	app.trans_blackscreenB = 255
	app.buttb_trans = 0
	app.butta_trans = 0
end

function app.enfocar(id) ---- enfoca la ventana con el numero de index referente al elemeto en la fishbar espesificado 
	if id > table.maxn(fishbar.apps) then return end
	if fishbar.apps[id] == nil then return end
	if fishbar.apps_focus == id then return end

	fishbar.apps_focus = id
	descktop.focoin = "window"
	if app.closeOtherWindow == false then app.trans_blackscreenB = 255 else app.closeOtherWindow = false end
	app.buttb_trans = 0
	app.butta_trans = 0
	fishbar.apps[id].minimize = false
	sdk.restartX()
end

function app.desenfocar(chunk_funcion) ---- desenfoca la ventana actualmente enfocada y ejecuta su argumento [string] como un chunk
if app.desenfocando == true then return end

app.tmp_screen = app.screenToImage()
app.desenfocando = true

if chunk_funcion == nil then 
	app.efectoDesenfoque = nil
else
	app.efectoDesenfoque = chunk_funcion
end

end

function app.changeFocus(foco) ---- cambia el foco al numero de id definido
if fishbar.apps_focus == foco then return end
if fishbar.panel_activado == true then return end

if descktop.focoin == "window" then
	app.desenfocar("app.de.changefocus("..foco..")")
else 
	fishbar.apps_focus = foco
	app.enfocarActual()
end

end

function app.isload(ID) -- funcion que comprueva si esta cargada la ID de aplicacion que tiene como argumento
	if app.getNumIDs(ID) == 0 then return false end
	return true
end

function app.minimize(index) -- Funcion que minimiza la aplicacion con el index referente a la fishbar que tiene como argumento
if index == 0 then return end
if fishbar.apps[index] == nil then return end
fishbar.apps[index].minimize = true 

app.changeFocus(app.getNextMaximize(index))
end

function app.getNextMaximize(id_window) 
if #fishbar.apps == 0 then
	return 0 
end

local comz = 0

if id_window == nil then
	comz = id_window
	if id_window == 1 then return 0 end
	if id_window == 0 then comz = #fishbar.apps end
else
	comz = fishbar.apps_focus

	if fishbar.apps_focus == 1 then return 0 end
	if fishbar.apps_focus == 0 then comz = #fishbar.apps end
end

local nums = {}

for i = 1,#fishbar.apps do
	if fishbar.apps[i].minimize == false and i <= comz then nums[#nums + 1] = i end
end

if #nums <= 0 then return 0 end

return nums[#nums]

end

function app.loadLanguage(id)  --- Carga el lenguage de la aplicacion con el ID pasado como argumento
	id = tostring(id)
	assert(loadstring(id..".lng = {}"))();  --- Inicializando tabla de lenguaje de la aplicacion
	
	if files.exists("ms0:/FISHELL/APP/"..id.."/lng/"..LOG_LANGUAGE..".lua") then
		dofile("ms0:/FISHELL/APP/"..id.."/lng/"..LOG_LANGUAGE..".lua")
	else		
		if files.exists("ms0:/FISHELL/APP/"..id.."/lng/".."unknown"..".lua") then
			dofile("ms0:/FISHELL/APP/"..id.."/lng/".."unknown"..".lua")
		end
		
		if files.exists("ms0:/FISHELL/APP/"..id.."/lng/".."english"..".lua") then
			dofile("ms0:/FISHELL/APP/"..id.."/lng/".."english"..".lua")
		end
		
		if files.exists("ms0:/FISHELL/LANG/"..LOG_LANGUAGE.."/APP/"..id..".lua") then
			dofile("ms0:/FISHELL/LANG/"..LOG_LANGUAGE.."/APP/"..id..".lua")
		end
	end
end

function app.getFirstIndex(ID)
index = 0
for i = 1,table.maxn(fishbar.apps) do
	if fishbar.apps[i].id == ID then
		index = i
		break
	end
end

return index
end

function app.getFromID(ID)
local app = {}

for i = 1,table.maxn(fishbar.apps) do
	if fishbar.apps[i].id.."["..fishbar.apps[i].index.."]" == ID then
		app = fishbar.apps[i]
		break
	end
end

return app
end

function app.minimeAll() -- Minimiza todas las ventanas
for i = 1,table.maxn(fishbar.apps) do
	fishbar.apps[i].minimize = true
end
end

function app.isMinimeAll() -- devuelve true si todas las ventanas estan minimizadas o false si no lo estan.
	local total = #fishbar.apps
	local actual = 0
	
	for i = 1,table.maxn(fishbar.apps) do
		if fishbar.apps[i].minimize == true then
			actual = actual + 1
		end
	end
	
	if actual >= total then
		return true
	else
		return false
	end
end

function app.showAllWindows() --- MAximiza todas las ventanas

	for i = 1,#fishbar.apps do
		fishbar.apps[i].minimize = false
	end
	
	if descktop.focoin == "window" then
	
	else
		if fishbar.apps[1] ~= nil then app.enfocar(1) end
	end
end

function app.closeAllIds(id)
	if id == nil then return end
	
	for i = 1,#fishbar.apps do
		if fishbar.apps[i].id == id then
			app.close(i)
		end
	end
end

function lockWindowsId(id)
	if id == nil then return end
	
	for i = 1,#fishbar.apps do
		if fishbar.apps[i].id == id then
			fishbar.apps[i].crash = true
		end
	end
end

function image.scale(imagen,porcent) --- Funcion Extra que escala una imagen en su porcentage pasado como argumento
-- retorna w,h
if imagen == nil then return end

if porcent == nil or porcent == 100 then
	imagen:reset()
end

local h = imagen:height()
local w = imagen:width()

local rh = math.floor((h / 100) * porcent)
local rw = math.floor((w / 100) * porcent)

imagen:resize(rw,rh)

return rw,rh
end

--------------------------------------------------------------------------
----------------_Funciones para el desenfoque de ventanas_----------------
--------------------------------------------------------------------------

app.de = {}

function app.de.load(ID,input)
app.load(ID,input)
end

function app.de.openMainMenu()
fishbar.panel_activado = true
descktop.focoin = "escritorio"
fishbar.PanelresetItemsPosicion()
sdk.restartX()
end

function app.de.changefocus(foco)
--screen.waitvblankstart(15)
fishbar.apps_focus = foco
app.enfocarActual()
sdk.restartX()
end