------------------------------------
---- Modulo PSP PLUGIN MANAGER -----
---- @Autor: zerozelta -------------
------------------------------------

ppmanager = {}

ppmanager.dispositivo = "ms0:"

if system.isGO then
	ppmanager.dispositivo = "ef0:"
end

function ppmanager.loadPlugins(file)

	if system.isGO then
		disp = "ef0:"
	else
		disp = "ms0:"
	end

	local path = disp.."/seplugins/"..file
	local result = {}
	
	if files.exists(path) == false then
		return result
	end

	local plugs = uld.filesRead(path)
	
	--- En esta seccion cargamos los plugins a un objeto plugin-list ---
	
	for i = 1,#plugs do
		local esp_tab = string.explode(plugs[i]," ")
		local disp = string.sub(esp_tab[1],1,5)
		local exists_ = false
		local valor = "0"
		local rline = plugs[i]
		
		for i = #esp_tab[1] - 1,#rline do
			local n = string.sub(rline,i,i)
			if n == "1" or n == "0" then
				valor = n
			end
		end
		
		if files.exists(esp_tab[1]) then
			exists_ = true
		end
		
		table.insert(result,{ path = esp_tab[1] , value = valor , root = disp , fileExist = exists_ , document = file })
	end
	
	return result
end

function ppmanager.save(pl,file)
	-- pl: Plugin List (object)
	local disp
	
	if system.isGO then
		disp = "ef0:"
	else
		disp = "ms0:"
	end
	
	local ruta = disp.."/seplugins/"..file
	files.mkdir(disp.."/seplugins")
		
	-- Estableciendo objeto a texto en lineas
	local lines = {}
	
	for i = 1,#pl do
		table.insert(lines,pl[i].path.." "..pl[i].value)
	end
	
	uld.writeFile(ruta,string.format(table.concat(lines,"\n")),"w+")
	
	return ppmanager.loadPlugins(file)
end

function ppmanager.getVSH(disp)
	if disp == nil then
		if system.isGO then
			disp = "ef0:"
		else
			disp = "ms0:"
		end
	end
	
	return ppmanager.loadPlugins(disp,"vsh.txt")
end

function ppmanager.getGAME(disp)
	if disp == nil then
		if system.isGO then
			disp = "ef0:"
		else
			disp = "ms0:"
		end
	end
	
	return ppmanager.loadPlugins(disp,"game.txt")
end

function ppmanager.getPOPS(disp)
	if disp == nil then
		if system.isGO then
			disp = "ef0:"
		else
			disp = "ms0:"
		end
	end
	
	return ppmanager.loadPlugins(disp,"pops.txt")
end

function ppmanager.rename(pl,i,nombre,fisico)
	if files.exists(pl[i].path) == false then fisico = false end
	
	local lastPath = tostring(pl[i].path)
	local rname = files.nopath(pl[i].path)
	local body = string.sub(pl[i].path,1,#rname)
	local result = body..nombre

	pl[i].path = result
	
	if fisico == true then
		files.rename(lastPath,nombre)
	end
end

function ppmanager.swich(pl,i)
	if pl[i].value == "1" then
		ppmanager.desactivate(pl,i)
	else
		ppmanager.activate(pl,i)
	end
end

function ppmanager.activate(pl,i)
	pl[i].value = "1"
end

function ppmanager.desactivate(pl,i)
	pl[i].value = "0"
end

function ppmanager.uninstal(pl,i,fisico)
	if files.exists(pl[i].path) == false then
		fisico = false
	end	
	
	table.remove(pl,i)
	
	if fisico == true then
		files.remove(pl[i].path)
	end
end

function ppmanager.install(pl,linea,valor,document)
	linea = ppmanager.dispositivo..string.sub(linea,5,#linea)
	table.insert(pl,{ path = linea , value = valor})
	return ppmanager.save(pl,document)
end

function ppmanager.uninstallAll(pl,document)
	local ruta = ppmanager.dispositivo.."/seplugins/"..document
	pl = nil
	pl = {}
	
	uld.writeFile(ruta,"","w+")
	return pl
end

function ppmanager.moveDown(pl,i)
	if i >= #pl then return end
	local tab = pl[i]
	table.insert(pl,i + 2,tab)
	table.remove(pl,i)
end

function ppmanager.moveUp(pl,i)
	if i <= 1 then return end
	local tab = pl[i]
	table.remove(pl,i)
	table.insert(pl,i - 1,tab)
end

function ppmanager.free()
	ppmanager = nil
end