----------------------------------
---------- Script loader ---------
----------------------------------

-- Script que carga el contenido del shell de una sesion ya iniciada
-- Modulo Nativo Escrito por zerozelta zerozelta@hotmail.com


--- cargando informacion de la instalacion
dofile("ms0:/FISHELL/INSTALL/install.ini")

--- cargando lenguage
system.loadLanguage(INSTALL_LENGUAGE) --- se accede al texto por medio de getText([String] texto)

INSTALL_APP = {}
if files.exists("ms0:/FISHELL/INSTALL/install_apps.ini") then
	dofile("ms0:/FISHELL/INSTALL/install_apps.ini") --- Cargando lista de programas instalados
end

local function drawLoading(trans)
	local tw = screen.textwidth(getText("bienvenido"),0.65)
	local ps = (480 - tw) / 2
	
	if files.exists("ms0:/FISHELL/RDS/inicial.ice") then
		IMG_LOAD_FONDO:blend(0,0,trans)
		screen.print(ps,133,getText("bienvenido"),0.65,color.new(255,255,255,trans),color.new(104,164,220,trans))
		screen.flip()
	else
		IMG_LOAD_FONDO:blend(0,0,trans)
		screen.flip()
	end
end

if files.exists("ms0:/FISHELL/RDS/inicial.ice") then
	IMG_LOAD_FONDO = image.load("ms0:/FISHELL/IMG/SYSTEM/sesion.png")
else
	IMG_LOAD_FONDO = image.load("ms0:/FISHELL/IMG/SYSTEM/restart.png")
end

for i = 0,255,8 do
	drawLoading(i)
end

drawLoading(255)

-----------------_Cargando recursos_--------------------
 
--- cargando informacion del usuario logeado
linea = uld.filesRead("ms0:/FISHELL/RDS/LOG/LOGED.ISF")
linea = uld.code.reverse(linea[1],2)

tabla = string.explode(linea,":")
if table.maxn(tabla) ~= 2 then return false end

LOG_USER = tostring(tabla[1])
LOG_TIME = tonumber(tabla[2])
LOG_PATH = "ms0:/FISHELL/USR/"..LOG_USER.."/"
LOG_DESCKTOP = 1
LOG_LENGUAGE = INSTALL_LENGUAGE
LOG_LANG = LOG_LENGUAGE
LOG_LANGUAGE = LOG_LENGUAGE

cfg = {}
dofile(LOG_PATH.."data.ini") -- Cargando tarjeta de usuaro

system.scannUpdate(LOG_USER) --- Escaneando sistema de usuario (actualiza el usuario si se detecta alguna actualizacion)

system.dofile(LOG_PATH.."CUSTOM/cfg.ini") -- Cargando configuracion de perzonalizacion del usuario LOGEADO

if files.exists("ms0:/FISHELL/LANG/"..LOG_LENGUAGE.."/") then
	LOG_LANG_PATH = "ms0:/FISHELL/LANG/"..LOG_LENGUAGE.."/"
else
	LOG_LANG_PATH = "ms0:/FISHELL/LANG/unknown/"
end

if files.exists("ms0:/FISHELL/THEME/"..USR_TEMA.."/CUSTOM") then
	LOG_THEME_PATH = "ms0:/FISHELL/THEME/"..USR_TEMA.."/"
else
	LOG_THEME_PATH = "ms0:/FISHELL/THEME/".."default".."/"
	USR_TEMA = "default"
end

------------------------------------------------------------------
---_cargando los modulos basicos para el comienzo del sistema_----
------------------------------------------------------------------

system.dofile("ms0:/FISHELL/SRC/DOC/brightness.lua") 		--- Efectos de brillo en el sistema
system.dofile("ms0:/FISHELL/SRC/DOC/home.lua") 				--- Menu Home de fishell
system.dofile("ms0:/FISHELL/SRC/DOC/mouse.lua") 			--- interpretacion del puntero
system.dofile("ms0:/FISHELL/SRC/DOC/fishbar.lua") 			---- FISHBAR
system.dofile("ms0:/FISHELL/SRC/DOC/descktop.lua") 			--- Escritorio y sus accesos directos
system.dofile("ms0:/FISHELL/SRC/drives.lua") 				--- Controladores
system.dofile("ms0:/FISHELL/SRC/DOC/standby_pro.lua") 		--- Modulo standby
system.dofile("ms0:/FISHELL/SRC/DOC/app_manager.lua") 		--- Modulo Gestor de ventanas
system.dofile("ms0:/FISHELL/SRC/DOC/popup.lua") 			--- Menu de listas
system.dofile("ms0:/FISHELL/SRC/DOC/launcher.lua") 			--- Modulo lanzador
system.dofile("ms0:/FISHELL/SRC/DOC/option_panel.lua") 		--- Ventana de opcion (si no)
system.dofile("ms0:/FISHELL/SRC/DOC/gadgets.lua") 			--- Gadgets del escritorio
system.dofile("ms0:/FISHELL/SRC/DOC/semaforo.lua") 			--- Semaforo del escritorio
system.dofile("ms0:/FISHELL/SRC/DOC/main_menu.lua") 		--- Menu principal o de inicio
system.dofile("ms0:/FISHELL/SRC/DOC/cfgw.lua") 				--- Funciones para modificar las configuraciones
system.dofile("ms0:/FISHELL/SRC/DOC/exception_manager.lua") --- Funciones del control de excepciones

LOG_ACOUNT_TABLE = acount.getAcounTable(LOG_USER)

---_cargando configuracion personal del usuario_---
---------------------------------------------------

IMG_FONDO = descktop.loadFondo()

if cfg.wave == true then 
	system.dofile("ms0:/FISHELL/SRC/DOC/fsl_wave.lua")
	wave = fsl.wave.new("ms0:/FISHELL/IMG/SYSTEM/WAVES/blue.png",0,1.25) 
elseif cfg.fishbar_wave == true then
	system.dofile("ms0:/FISHELL/SRC/DOC/fsl_wave.lua")
end

if cfg.usbpersistent == true then usb.on() end

for i = 255,-10,-10 do
drawLoading(i)
end

IMG_LOAD_FONDO:free()
drawLoading = nil

if autoboot == nil then
	system.dofile("ms0:/FISHELL/SRC/DOC/autoboot.lua")
end

autoboot.active() ---- Activando el plugin autoboot

if files.exists("ms0:/FISHELL/RDS/inicial.ice") then
	files.remove("ms0:/FISHELL/RDS/inicial.ice") --- Elimina lo que indica que fue un iniicio de sesion
end

if cfg.cpu == nil then
	cfg.cpu = 333
end

os.cpu(cfg.cpu) -- Estableciendo CPU a la configuracion del usuario  

system.dofile("ms0:/FISHELL/SRC/kernel.lua") -- cargando el nucleo del sistema