--[[ SDK para la programacion de aplicaciones ]]--

sdk = {}

	--[[funciones de pintado]]--
	
sdk.x = 8
sdk.y = 25
sdk.w = 463
sdk.h = 198
sdk.objx = sdk.x

function sdk.imageBlit(imagen,x,y)
ix = 0
iy = 0

if x < sdk.x then
ix = sdk.x - x
x = 0 
end

if y < sdk.y then
iy = sdk.y - y
y = 0
end

imagen:blit(sdk.x + x,sdk.y + y,ix,iy,sdk.w,sdk.h)
end

	--[[funciones del sistema]]--

function sdk.closeAPP(index)

end

function sdk.shutdownSystem()
	system.shutdown()
end

function sdk.deleteFile(ruta,recursivo)
	if files.exists(ruta) == false then return end
	
	if recursivo == nil then
		recursivo = true
	end
	
	system.printLabel("03","Eliminando...")
	files.remove(ruta,recursivo) 
	system.closeLabel()
	
	if files.exists(ruta) then
		system.mensaje("Error","","El archivo/directorio no se pudo eliminar")
	end
end

function sdk.renameFile(ruta)
local extencion = files.ext(ruta)

if extencion == nil then
	extencion  = ""
end

if files.exists(ruta) == false then system.mensaje("Error","","El archivo no existe") return end
if osk == nil then system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua") end

--nombre = osk.getText(lng["escribe el nuevo nombre del archivo"],files.nopath(ruta),50,"difuse","osk")
local nombre = ""

if extencion == "" then
	nombre = osk.getText(lng["escribe el nuevo nombre del archivo"],files.nopath(ruta),50)
	if nombre == nil then return end
	
	local setext = string.explode(nombre,":") 
	
	if #setext > 1 then
		extencion = setext[#setext]
		nombre = setext[1]
	end
	
	if files.exists(files.nofile(ruta)..nombre) and files.nofile(ruta)..nombre ~= ruta then
	system.mensaje("Alerta","","El nombre que escogi para este archivo ya existe, por lo que no se ha efectuado ningn cambio")
	return ruta
	end
else
	nombre = osk.getText(lng["escribe el nuevo nombre del archivo"],string.sub(files.nopath(ruta),1,#files.nopath(ruta) - (#extencion + 1)),50)
	if nombre == nil then return end
	
	local setext = string.explode(nombre,":") 
	if #setext > 1 then
		extencion = setext[#setext]
		
		nombre = setext[1]
	end
	
	if files.exists(files.nofile(ruta)..nombre.."."..extencion) then
	system.mensaje("Alerta","","El nombre que escogi para este archivo ya existe, por lo que no se ha efectuado ningn cambio")
	return ruta
	end
end

system.printLabel("03",lng["renombrando"])

local result = ""

if extencion == "" then
	files.rename(ruta,nombre)
	result = nombre
else
	files.rename(ruta,nombre.."."..extencion)
	result = nombre.."."..extencion
end

system.closeLabel()

if files.exists(files.nofile(ruta)..result) == false then
	system.mensaje(lng["error"],"",lng["no se pudo renombrar el archivo"])
	return ruta
else
	--system.mensaje(lng["mensaje"],"",lng["el archivo se renombro correctamente"])
	return files.nofile(ruta)..result
end

end

function sdk.getPropieties(ruta)
system.dofile("ms0:/FISHELL/SRC/PORTAL/get_propieties.lua")
gp_.play(ruta)
end

function sdk.restartX()
	sdk.x = 8
	sdk.objx = sdk.x
end

function sdk.encrypt(texto,llave)
	if texto == nil then return nil end

	local tmp_codigo = {}

	for i = 1,#texto do
		chare = string.sub(texto,i,i + 1)
		chare_code = tonumber(string.byte(chare)) + llave
		table.insert(tmp_codigo,tostring(chare_code))
	end
	
	local codigo = table.concat(tmp_codigo,",")

	return codigo
end

function sdk.desencrypt(codigo,llave)
	if codigo == nil then return end

	local tmp_texto = {}
	tmp_texto = string.explode(codigo,",")
	local texto = {}

	for i = 1,#tmp_texto do
		local num = tmp_texto[i]
		local txt = string.char(tonumber(num - llave))
		table.insert(texto,txt)
	end
	
	texto = table.concat(texto)
	return texto
end


function sdk.copyfile(ruta_origen,ruta_destino)
	if files.exists(ruta_origen) == false then 
		system.mensaje("Error","","El archivo de origen no existe")
		return 
	end
	
	if files.exists(ruta_destino) == false then 
		system.mensaje("Error","","El folder de destino no existe")
		return 
	end
	
	local file = uld.getFile(ruta_origen)
	if file == nil then
		system.mensaje("Error","","No se encontr el archivo de origen: "..ruta_origen)
		return
	end
	
	local freespace = files.freespace()
	
	if file.directory == true then
		system.printLabel("03","Analizando")
		local dirsize = sdk.getFileSize(file.name)
		system.closeLabel()
	
		if dirsize > freespace then
			system.mensaje("Alerta","","No hay suficiente espacio disponible en la memoria, se necesitan "..files.sizeformat(dirsize - freespace).." adicionales")
			return
		end
	end
	
	if file.size > freespace and file.directory == false then
		system.mensaje("Alerta","","No hay suficiente espacio disponible en la memoria, se necesitan "..files.sizeformat(file.size - freespace).." adicionales")
		return
	end
	
	local extencion  = files.ext(ruta_origen)
	
	if extencion == nil then
		extencion = ""
	else
		extencion = "."..extencion
	end
	
	local comienzo
	if file.directory == true then
		comienzo = files.nopath(ruta_origen)
	else
		comienzo = string.sub(files.nopath(ruta_origen),1,#files.nopath(ruta_origen) - #extencion)
	end

	if osk == nil then
		system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua")
	end

	local nombre = string.sub(files.nopath(ruta_origen),1,#files.nopath(ruta_origen) - #extencion)
	
	if files.exists(ruta_destino.."/"..nombre..extencion) == true then
		nombre = osk.getText("Elija un nombre para el archivo de destino (no necesita aadir la extencin del archivo, el sistema la aadir automaticamente)",comienzo,50)
	end
	
	if nombre == nil then --- en caso de cancelar la introduccion de texto
		return
	end

	local result
	
	if string.sub(ruta_destino,#ruta_destino,#ruta_destino) == "/" then
		result = ruta_destino..nombre..extencion
	else
		result = ruta_destino.."/"..nombre..extencion
	end
	
	local chunk = "sdk.mkcopyfile('"..ruta_origen.."','"..result.."',true)"
	
	if files.exists(result) then --- en caso de que se requiera sobreescrivir datos
		optionpanel.init("El archivo que desea pegar ya existe, desea sobreescribir los datos?",chunk)
		return
	end
	
	return sdk.mkcopyfile(ruta_origen,result)
end

function sdk.mkcopyfile(ruta_origen,ruta_destino,inmessen)
	system.printLabel("03","Copiando archivos")
	files.copy(ruta_origen,ruta_destino,true,true)
	system.closeLabel()
	
	---system.mensaje("mensaje","","Origen: "..ruta_origen.."   Destino: "..ruta_destino)
	
	if ID004EA ~= nil then
		ID004EA.portapapeles = nil
	end
	
	if files.exists(ruta_destino) then
		if inmessen == true then
			system.mensaje("Mensaje","","El archivo se copio correctamente en: "..ruta_destino)
		end
	else
		system.mensaje("Mensaje","","El archivo no se pudo copiar")
		return
	end
	
	return ruta_destino
end

function sdk.mkdir(ruta)

	if string.sub(ruta,#ruta,#ruta) == "/" then
		ruta = string.sub(ruta,1,#ruta - 1)
	end
	
	if osk == nil then
		system.dofile("ms0:/FISHELL/SRC/DOC/osk.lua")
	end
	
	local nombre = osk.getText("Escriba el nombre de la nueva carpeta (Recuerda no usar caracteres que no esten en el alfabeto ni signos de puntuacin)",lng["nueva carpeta"],50)
	
	if nombre == nil then return end
	
	if files.exists(ruta.."/"..nombre) then
		system.mensaje("Alerta","","El nombre de la carpeta ya existe, asi que no se ha efectuado ningn cambio")
		return
	end
	
	files.mkdir(ruta.."/"..nombre) 
	
	if files.exists(ruta.."/"..nombre) then
		return ruta.."/"..nombre
	else
		system.mensaje("Error","","No se puedo crear la carpeta")
	end
end

function sdk.getFileSize(ruta)
	local file = uld.getFile(ruta)
	local size = 0
	
	if file.directory then
		local archivos = files.list(ruta)
		for i = 1,#archivos do
			if archivos[i].directory then
				size = size + sdk.getFileSize(archivos[i].name)
			else
				size = size + archivos[i].size
			end
		end
	else
		size = file.size
	end
	
	return size
end

function sdk.cutFile(orig,dest)
	system.printLabel("03","Cortando archivos")
	
	if string.sub(dest,#dest,#dest) == "/" then
		dest = string.sub(dest,1,#dest - 1)
	end
	
	local rdest = dest.."/"..files.nopath(orig)
	
	if rdest == orig then
		system.closeLabel()
		system.mensaje("Alerta","","El archivo de destino hace referencia al archivo de origen, por lo que no se ha efectuado ningn cambio")
		return orig
	end
	
	if files.exists(rdest) then
		system.closeLabel()
		system.mensaje("Alerta","","Ya existe un archivo con el mismo nombre en el directorio seleccionado, renombre el archivo: "..rdest.." e intente pegarlo de nuevo.")
		return rdest
	end
	
	files.copy(orig,rdest,true,true)
	
	if files.exists(rdest) == false then
		system.closeLabel()
		system.mensaje("Error","","No se ha podido cortar y pegar el documento, pero se ha conservado el archivo de origen")
		return orig
	end 
	
	files.remove(orig,true)
	
	if ID004EA ~= nil then
		ID004EA.portapapeles = nil
		ID004EA.ppToCut = false
	end
	
	system.closeLabel()
	return rdest
end

function sdk.cristalEffect(x,y,w,h,trans)
--w = 459 ,h= 46 , x = 2 , y = 

	if trans == nil then trans = 0 end
	
	if sdk.x > (0 - x) and sdk.x + x + w < 480 then
		image.blit(IMG_FONDO,sdk.x + x,sdk.y + y,sdk.x + x,sdk.y + y,w,h)
	else
		if sdk.x < (0 - x) and sdk.x - x > (0 - w) then
			image.blit(IMG_FONDO,0,sdk.y + y,0,sdk.y + y,w + (sdk.x + x),h)
		elseif 478 - sdk.x > x then
			image.blit(IMG_FONDO,sdk.x + x,sdk.y + y,sdk.x + x,sdk.y + y,478 - (sdk.x),h)
		end
	end
	
	if trans > 0 then 
		if cfg.color_backgrounds == nil then
			draw.fillrect(sdk.x + x,sdk.y + y,w,h,color.new(255,255,255,trans))
		else
			draw.fillrect(sdk.x + x,sdk.y + y,w,h,color.new(cfg.color_backgrounds.R,cfg.color_backgrounds.G,cfg.color_backgrounds.B,trans))
		end
	elseif cfg.color_backgrounds ~= nil then
		draw.fillrect(sdk.x + x,sdk.y + y,w,h,color.new(cfg.color_backgrounds.R,cfg.color_backgrounds.G,cfg.color_backgrounds.B,trans + 70))
	end
	
	draw.rect(sdk.x + x,sdk.y + y,w,h,color.new(35,35,35))
end

function sdk.effectFullScreen()
	local img_screen = screen.toimage()
	
	for i = 0,480,7.7 do
		local w = 200 + i
		local x = (480 / 2) - (w / 2) 
		local y = (272 / 2) - (i / 2)
		
		img_screen:blend(0,0)
		draw.fillrect(x,y,w,i,color.new(0,0,0,i))
		screen.flip()
	end
	
	
end

system.dofile("ms0:/FISHELL/SRC/SDK/scrollbar.lua")
system.dofile("ms0:/FISHELL/SRC/SDK/awt.lua")