--[[ MODULO SCROLL BAR FISHELL @ zerozelta ]]--

scrollbar = {}
scrollbar.defw = 8
scrollbar.color_backgrund = color.new(233,233,233)
scrollbar.color_pst = color.new(111,111,111)
scrollbar.color_border = color.new(130,130,130)

function scrollbar.new(x,y,h,va,vt) --[OBJ SCROLLBAR]--
	local obj = {}
	obj.x = x
	obj.y = y
	
	obj.w = scrollbar.defw
	obj.h = h
	
	obj.va = va
	obj.vt = vt
	
	obj.pdb = 0
	obj.tdb = 0
	
	obj.color_back = scrollbar.color_backgrund
	obj.color_pst = scrollbar.color_pst
	obj.color_border = scrollbar.color_border
	
	
	return obj
end

function scrollbar.draw(obj,trans)
	if obj == nil then return false end
	if obj.vt <= 0 then obj.vt = 1 end
	if obj.va <= 0 then obj.va = 1 end
	
	if trans == nil then
		trans = 255
	end
	
	local tdb = obj.h / obj.vt
	local pdb
	
	if obj.vt == 1 then
		pdb = 0
		tdb = obj.h
	else
		pdb = (obj.va - 1) * tdb
		if obj.va >= obj.vt then
			pdb = obj.h - obj.tdb
		end
	end
	
	if pdb < 0 then pdb = 0 end
	if tdb > obj.h then tdb = obj.h end
	
	if tdb > obj.tdb then obj.tdb = obj.tdb + 2 end
	if tdb < obj.tdb then obj.tdb = obj.tdb - 2 end
	
	if pdb > obj.pdb then obj.pdb = obj.pdb + 2 end
	if pdb < obj.pdb then obj.pdb = obj.pdb - 2 end

	draw.fillrect(obj.x + 1,obj.y,obj.w - 2,obj.h,color.new(233,233,233,trans))
	draw.rect(obj.x + 1,obj.y,obj.w - 2,obj.h,color.new(130,130,130,trans))
	draw.fillrect(obj.x,obj.y + obj.pdb,obj.w,obj.tdb,color.new(111,111,111,trans))
	draw.rect(obj.x,obj.y + obj.pdb,obj.w,obj.tdb,color.new(30,30,30,trans))
	draw.fillrect(obj.x + 1,obj.y + obj.pdb + 1,2,obj.tdb - 2,color.new(180,180,180,trans))
	
	return true
end

function scrollbar.setVal(obj,va,vt)
	if obj == nil then return false end
	obj.vt = vt
	obj.va = va
	return true
end

function scrollbar.setLocation(obj,x,y)
	if obj == nil then return false end
	obj.x = x
	obj.y = y
	return true
end