--- MODULO NATIVO DEL ULTIMATE LIBRARY DEV 

----------------------------------------------------
--- Libreria privada para proyectos de zerozelta ---
----------------------------------------------------

--- licencia para el uso EXCLUSIVO del sistema fishell ---
--- @zerozelta | zerozelta@hotmail.com

uld.code = {}

function uld.loadlib(name)  
	if name == nil then return end 
	
	if files.exists("uld_lib/modulos/"..name..".lua") then
		dofile("uld_lib/modulos/"..name..".lua")  --- Prioridad para archivos .lua
		return true
	else
		if files.exists("uld_lib/modulos/"..name..".lue") then
			dofile("uld_lib/modulos/"..name..".lue")
			return true
		else
			return false
		end
	end
end

function uld.dofile(ruta)

	rut = string.sub(ruta,0,string.len(ruta) - 3)

	if files.exists(rut.."lue") then 
		return dofile(rut.."lue")
	end

	return dofile(ruta)
end

function uld.splash(img,tiempo)
local imagen = image.load(img)
for i = 0,255,4 do
	alfa = i
	image.blend(imagen,0,0,alfa)
	screen.flip()
end

screen.waitvblankstart(tiempo)

for i = 0,255,4 do
	alfa = 255 - i
	image.blend(imagen,0,0,alfa)
	screen.flip() 
end

image.free(imagen)
end

--- Funcion que escribe en el fichero seleccionado(string) el contenido en el modo definido
function uld.writeFile(fichero,contenido,modo)
	local archivo = io.open(fichero,modo);
	archivo:write(contenido);
	archivo:flush();
	archivo:close();
	archivo = nil
end

--- Funcion que lee un fichero(string) y devuelbe su contenido en una tabla
function uld.filesRead(fichero)
	local contenido = {}

	for linea in io.lines(fichero) do
		table.insert(contenido,linea)
	end

	return contenido
end

--- Funcion que imprime una imagen con el porcentage dado de opacidad
function uld.blend(imagen,x,y,porcentage)
	p = (255 / 100) * porcentage
	imagen:blend(x,y,p)
end

--- Funcion que comprueva si un objeto esta sobre el sector definido
function uld.isOver(x,y,w,h,objX,objY)
	if x == nil or y == nil then return false end

	if objX < x then return false end
	if objX > x + w then return false end
	if objY < y then return false end
	if objY > y + h then return false end

	return true
end

function uld.code.new(texto,llave)
	if texto == nil then return nil end

	local tmp_codigo = {}

	for i = 1,#texto do
		chare = string.sub(texto,i,i + 1)
		chare_code = tonumber(string.byte(chare)) + llave
		table.insert(tmp_codigo,tostring(chare_code))
	end
	
	local codigo = table.concat(tmp_codigo,",")

	return codigo
end

function uld.code.reverse(codigo,llave)
	if codigo == nil then return end

	local tmp_texto = {}
	tmp_texto = string.explode(codigo,",")
	local texto = {}

	for i = 1,#tmp_texto do
		local num = tmp_texto[i]
		num = tonumber(num)
		local txt = string.char(tonumber(num - llave))
		table.insert(texto,txt)
	end
	
	texto = table.concat(texto)
	return texto
end

function uld.toInt(texto)
	local mt = "0"..texto
	mt = mt + 0 + 0
	return mt
end

--- funcion que permite centrar un texto
function uld.printCenter(x,y,text,size,color,sombra,width,fuente)
	if text == nil then return end
	local w = 0

	if fuente == nil then
		w = screen.textwidth(text,size)
	else
		w = screen.textwidth(fuente,text,size)
	end

	local posX = 0
	if w > width then posX =  0 - ((w - width) / 2) else posX = (width - w) / 2 end

	if fuente == nil then
		screen.print(x + posX,y,text,size,color,sombra)
	else
		screen.print(fuente,x + posX,y,text,size,color,sombra)
	end

end

function uld.copyImage(entrada)
	local salida = image.create(entrada:width(),entrada:height(),0x0)
	salida:blit(0,0,entrada)
	return salida
end

function uld.getInterline(texto)
	local int = table.maxn(string.explode(texto,"\n")) - 1
	return int
end

function uld.getFile(ruta)
	if files.exists(ruta) == false then return end

	if string.sub(ruta,#ruta,#ruta) == "/" then
		ruta = string.sub(ruta,1,#ruta - 1)
	end

	ruta = string.lower(ruta)

	if ruta == "ms0:" then
		obj = {name = "ms0:/" , directory = true }
		return obj
	end

	padre = files.list(files.nofile(ruta))

	obj = nil
	if table.maxn(padre) == 0 then return nil end

	for i = 1,table.maxn(padre) do
		if string.lower(padre[i].name) == ruta then
			obj = padre[i]
			break
		end
	end

	return obj
end